/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30706

/* Bison version string.  */
#define YYBISON_VERSION "3.7.6"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 71 "./grammar.y"


#include <symbol.h>
#include <semantic.h>

#define YYMAXDEPTH 150

extern int yylex(void);

/* declaration specifier attributes for the typedef statement currently being
 * scanned
 */
static int cur_decl_spec_flags;

/* pointer to parameter list for the current function definition */
static ParameterList *func_params;

/* A parser semantic action sets this pointer to the current declarator in
 * a function parameter declaration in order to catch any comments following
 * the parameter declaration on the same line.  If the lexer scans a comment
 * and <cur_declarator> is not NULL, then the comment is attached to the
 * declarator.  To ignore subsequent comments, the lexer sets this to NULL
 * after scanning a comment or end of line.
 */
static Declarator *cur_declarator;

/* temporary string buffer */
static char *temp_buf = 0;
static size_t temp_len = 0;

/* table of typedef names */
static SymbolTable *typedef_names;

/* table of define names */
static SymbolTable *define_names;

/* table of type qualifiers */
static SymbolTable *type_qualifiers;

/* information about the current input file */
typedef struct {
    char *base_name;		/* base input file name */
    char *file_name;		/* current file name */
    size_t len_file_name;	/* ...its allocated size */
    FILE *file;			/* input file */
    unsigned line_num;		/* current line number in input file */
    FILE *tmp_file;		/* temporary file */
    long begin_comment;		/* tmp file offset after last written ) or ; */
    long end_comment;		/* tmp file offset after last comment */
    boolean convert;		/* if TRUE, convert function definitions */
    boolean changed;		/* TRUE if conversion done in this file */
} IncludeStack;

static IncludeStack *cur_file;	/* current input file */

#include "yyerror.c"

static int haveAnsiParam(void);

/* Flags to enable us to find if a procedure returns a value.
 */
static int return_val,		/* nonzero on BRACES iff return-expression found */
  returned_at;			/* marker for token-number to set 'return_val' */

#if OPT_LINTLIBRARY
static const char *
dft_decl_spec(void)
{
    return (lintLibrary() && !return_val) ? "void" : "int";
}

#else
#define dft_decl_spec() "int"
#endif

static int
haveAnsiParam(void)
{
    Parameter *p;
    if (func_params != 0) {
	for (p = func_params->first; p != 0; p = p->next) {
	    if (p->declarator->func_def == FUNC_ANSI) {
		return TRUE;
	    }
	}
    }
    return FALSE;
}

static void
need_temp(size_t need)
{
    if (need > temp_len) {
	if (need < MAX_TEXT_SIZE)
	    need = MAX_TEXT_SIZE;
	if (need < temp_len * 2)
	    need = temp_len * 2;
	temp_buf = type_realloc(char, temp_buf, need);
	temp_len = need;
    }
}


#line 175 "y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    T_IDENTIFIER = 258,            /* T_IDENTIFIER  */
    T_TYPEDEF_NAME = 259,          /* T_TYPEDEF_NAME  */
    T_DEFINE_NAME = 260,           /* T_DEFINE_NAME  */
    T_AUTO = 261,                  /* T_AUTO  */
    T_EXTERN = 262,                /* T_EXTERN  */
    T_REGISTER = 263,              /* T_REGISTER  */
    T_STATIC = 264,                /* T_STATIC  */
    T_TYPEDEF = 265,               /* T_TYPEDEF  */
    T_INLINE = 266,                /* T_INLINE  */
    T_EXTENSION = 267,             /* T_EXTENSION  */
    T_ATTRIBUTE = 268,             /* T_ATTRIBUTE  */
    T_CHAR = 269,                  /* T_CHAR  */
    T_DOUBLE = 270,                /* T_DOUBLE  */
    T_FLOAT = 271,                 /* T_FLOAT  */
    T_INT = 272,                   /* T_INT  */
    T_VOID = 273,                  /* T_VOID  */
    T_LONG = 274,                  /* T_LONG  */
    T_SHORT = 275,                 /* T_SHORT  */
    T_SIGNED = 276,                /* T_SIGNED  */
    T_UNSIGNED = 277,              /* T_UNSIGNED  */
    T_ENUM = 278,                  /* T_ENUM  */
    T_STRUCT = 279,                /* T_STRUCT  */
    T_UNION = 280,                 /* T_UNION  */
    T_Bool = 281,                  /* T_Bool  */
    T_Complex = 282,               /* T_Complex  */
    T_Imaginary = 283,             /* T_Imaginary  */
    T_LONG_DOUBLE = 284,           /* T_LONG_DOUBLE  */
    T_TYPE_QUALIFIER = 285,        /* T_TYPE_QUALIFIER  */
    T_BRACKETS = 286,              /* T_BRACKETS  */
    T_LBRACE = 287,                /* T_LBRACE  */
    T_MATCHRBRACE = 288,           /* T_MATCHRBRACE  */
    T_ELLIPSIS = 289,              /* T_ELLIPSIS  */
    T_INITIALIZER = 290,           /* T_INITIALIZER  */
    T_STRING_LITERAL = 291,        /* T_STRING_LITERAL  */
    T_ASM = 292,                   /* T_ASM  */
    T_ASMARG = 293,                /* T_ASMARG  */
    T_VA_DCL = 294                 /* T_VA_DCL  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define T_IDENTIFIER 258
#define T_TYPEDEF_NAME 259
#define T_DEFINE_NAME 260
#define T_AUTO 261
#define T_EXTERN 262
#define T_REGISTER 263
#define T_STATIC 264
#define T_TYPEDEF 265
#define T_INLINE 266
#define T_EXTENSION 267
#define T_ATTRIBUTE 268
#define T_CHAR 269
#define T_DOUBLE 270
#define T_FLOAT 271
#define T_INT 272
#define T_VOID 273
#define T_LONG 274
#define T_SHORT 275
#define T_SIGNED 276
#define T_UNSIGNED 277
#define T_ENUM 278
#define T_STRUCT 279
#define T_UNION 280
#define T_Bool 281
#define T_Complex 282
#define T_Imaginary 283
#define T_LONG_DOUBLE 284
#define T_TYPE_QUALIFIER 285
#define T_BRACKETS 286
#define T_LBRACE 287
#define T_MATCHRBRACE 288
#define T_ELLIPSIS 289
#define T_INITIALIZER 290
#define T_STRING_LITERAL 291
#define T_ASM 292
#define T_ASMARG 293
#define T_VA_DCL 294

/* Value type.  */


extern YYSTYPE yylval;

int yyparse (void);


/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_3_ = 3,                         /* '('  */
  YYSYMBOL_4_ = 4,                         /* '*'  */
  YYSYMBOL_5_ = 5,                         /* '&'  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_TYPEDEF_NAME = 7,             /* T_TYPEDEF_NAME  */
  YYSYMBOL_T_DEFINE_NAME = 8,              /* T_DEFINE_NAME  */
  YYSYMBOL_T_AUTO = 9,                     /* T_AUTO  */
  YYSYMBOL_T_EXTERN = 10,                  /* T_EXTERN  */
  YYSYMBOL_T_REGISTER = 11,                /* T_REGISTER  */
  YYSYMBOL_T_STATIC = 12,                  /* T_STATIC  */
  YYSYMBOL_T_TYPEDEF = 13,                 /* T_TYPEDEF  */
  YYSYMBOL_T_INLINE = 14,                  /* T_INLINE  */
  YYSYMBOL_T_EXTENSION = 15,               /* T_EXTENSION  */
  YYSYMBOL_T_ATTRIBUTE = 16,               /* T_ATTRIBUTE  */
  YYSYMBOL_T_CHAR = 17,                    /* T_CHAR  */
  YYSYMBOL_T_DOUBLE = 18,                  /* T_DOUBLE  */
  YYSYMBOL_T_FLOAT = 19,                   /* T_FLOAT  */
  YYSYMBOL_T_INT = 20,                     /* T_INT  */
  YYSYMBOL_T_VOID = 21,                    /* T_VOID  */
  YYSYMBOL_T_LONG = 22,                    /* T_LONG  */
  YYSYMBOL_T_SHORT = 23,                   /* T_SHORT  */
  YYSYMBOL_T_SIGNED = 24,                  /* T_SIGNED  */
  YYSYMBOL_T_UNSIGNED = 25,                /* T_UNSIGNED  */
  YYSYMBOL_T_ENUM = 26,                    /* T_ENUM  */
  YYSYMBOL_T_STRUCT = 27,                  /* T_STRUCT  */
  YYSYMBOL_T_UNION = 28,                   /* T_UNION  */
  YYSYMBOL_T_Bool = 29,                    /* T_Bool  */
  YYSYMBOL_T_Complex = 30,                 /* T_Complex  */
  YYSYMBOL_T_Imaginary = 31,               /* T_Imaginary  */
  YYSYMBOL_T_LONG_DOUBLE = 32,             /* T_LONG_DOUBLE  */
  YYSYMBOL_T_TYPE_QUALIFIER = 33,          /* T_TYPE_QUALIFIER  */
  YYSYMBOL_T_BRACKETS = 34,                /* T_BRACKETS  */
  YYSYMBOL_T_LBRACE = 35,                  /* T_LBRACE  */
  YYSYMBOL_T_MATCHRBRACE = 36,             /* T_MATCHRBRACE  */
  YYSYMBOL_T_ELLIPSIS = 37,                /* T_ELLIPSIS  */
  YYSYMBOL_T_INITIALIZER = 38,             /* T_INITIALIZER  */
  YYSYMBOL_T_STRING_LITERAL = 39,          /* T_STRING_LITERAL  */
  YYSYMBOL_T_ASM = 40,                     /* T_ASM  */
  YYSYMBOL_T_ASMARG = 41,                  /* T_ASMARG  */
  YYSYMBOL_T_VA_DCL = 42,                  /* T_VA_DCL  */
  YYSYMBOL_43_ = 43,                       /* ';'  */
  YYSYMBOL_44_ = 44,                       /* ','  */
  YYSYMBOL_45_ = 45,                       /* '='  */
  YYSYMBOL_46_ = 46,                       /* ')'  */
  YYSYMBOL_YYACCEPT = 47,                  /* $accept  */
  YYSYMBOL_program = 48,                   /* program  */
  YYSYMBOL_translation_unit = 49,          /* translation_unit  */
  YYSYMBOL_external_declaration = 50,      /* external_declaration  */
  YYSYMBOL_braces = 51,                    /* braces  */
  YYSYMBOL_linkage_specification = 52,     /* linkage_specification  */
  YYSYMBOL_declaration = 53,               /* declaration  */
  YYSYMBOL_54_1 = 54,                      /* $@1  */
  YYSYMBOL_any_typedef = 55,               /* any_typedef  */
  YYSYMBOL_opt_declarator_list = 56,       /* opt_declarator_list  */
  YYSYMBOL_declarator_list = 57,           /* declarator_list  */
  YYSYMBOL_function_definition = 58,       /* function_definition  */
  YYSYMBOL_59_2 = 59,                      /* $@2  */
  YYSYMBOL_60_3 = 60,                      /* $@3  */
  YYSYMBOL_61_4 = 61,                      /* $@4  */
  YYSYMBOL_opt_declaration_list = 62,      /* opt_declaration_list  */
  YYSYMBOL_declaration_list = 63,          /* declaration_list  */
  YYSYMBOL_decl_specifiers = 64,           /* decl_specifiers  */
  YYSYMBOL_decl_specifier = 65,            /* decl_specifier  */
  YYSYMBOL_storage_class = 66,             /* storage_class  */
  YYSYMBOL_type_specifier = 67,            /* type_specifier  */
  YYSYMBOL_type_qualifier = 68,            /* type_qualifier  */
  YYSYMBOL_struct_or_union_specifier = 69, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 70,           /* struct_or_union  */
  YYSYMBOL_init_declarator_list = 71,      /* init_declarator_list  */
  YYSYMBOL_init_declarator = 72,           /* init_declarator  */
  YYSYMBOL_73_5 = 73,                      /* $@5  */
  YYSYMBOL_asm_specifier = 74,             /* asm_specifier  */
  YYSYMBOL_enum_specifier = 75,            /* enum_specifier  */
  YYSYMBOL_enumeration = 76,               /* enumeration  */
  YYSYMBOL_any_id = 77,                    /* any_id  */
  YYSYMBOL_declarator = 78,                /* declarator  */
  YYSYMBOL_direct_declarator = 79,         /* direct_declarator  */
  YYSYMBOL_pointer = 80,                   /* pointer  */
  YYSYMBOL_opt_type_qualifiers = 81,       /* opt_type_qualifiers  */
  YYSYMBOL_type_qualifier_list = 82,       /* type_qualifier_list  */
  YYSYMBOL_parameter_type_list = 83,       /* parameter_type_list  */
  YYSYMBOL_parameter_list = 84,            /* parameter_list  */
  YYSYMBOL_parameter_declaration = 85,     /* parameter_declaration  */
  YYSYMBOL_opt_identifier_list = 86,       /* opt_identifier_list  */
  YYSYMBOL_identifier_list = 87,           /* identifier_list  */
  YYSYMBOL_identifier_or_ref = 88,         /* identifier_or_ref  */
  YYSYMBOL_abs_declarator = 89,            /* abs_declarator  */
  YYSYMBOL_direct_abs_declarator = 90      /* direct_abs_declarator  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   570

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  47
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  44
/* YYNRULES -- Number of rules.  */
#define YYNRULES  118
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  156

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   294


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     5,     2,
       3,    46,     4,     2,    44,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    43,
       2,    45,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   177,   177,   178,   182,   183,   187,   188,   189,   190,
     191,   192,   196,   203,   207,   214,   221,   232,   247,   246,
     258,   262,   269,   270,   274,   286,   299,   310,   298,   335,
     334,   363,   364,   365,   369,   370,   374,   375,   384,   385,
     386,   390,   394,   398,   402,   406,   410,   417,   421,   425,
     429,   433,   437,   441,   445,   449,   453,   457,   461,   465,
     469,   476,   477,   481,   485,   498,   507,   516,   525,   529,
     536,   540,   547,   557,   556,   568,   569,   576,   585,   594,
     603,   611,   612,   616,   628,   632,   636,   647,   657,   665,
     676,   682,   694,   698,   702,   709,   721,   722,   729,   733,
     740,   745,   750,   759,   762,   766,   771,   778,   782,   796,
     800,   811,   815,   826,   836,   840,   848,   855,   866
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "'('", "'*'", "'&'",
  "T_IDENTIFIER", "T_TYPEDEF_NAME", "T_DEFINE_NAME", "T_AUTO", "T_EXTERN",
  "T_REGISTER", "T_STATIC", "T_TYPEDEF", "T_INLINE", "T_EXTENSION",
  "T_ATTRIBUTE", "T_CHAR", "T_DOUBLE", "T_FLOAT", "T_INT", "T_VOID",
  "T_LONG", "T_SHORT", "T_SIGNED", "T_UNSIGNED", "T_ENUM", "T_STRUCT",
  "T_UNION", "T_Bool", "T_Complex", "T_Imaginary", "T_LONG_DOUBLE",
  "T_TYPE_QUALIFIER", "T_BRACKETS", "T_LBRACE", "T_MATCHRBRACE",
  "T_ELLIPSIS", "T_INITIALIZER", "T_STRING_LITERAL", "T_ASM", "T_ASMARG",
  "T_VA_DCL", "';'", "','", "'='", "')'", "$accept", "program",
  "translation_unit", "external_declaration", "braces",
  "linkage_specification", "declaration", "$@1", "any_typedef",
  "opt_declarator_list", "declarator_list", "function_definition", "$@2",
  "$@3", "$@4", "opt_declaration_list", "declaration_list",
  "decl_specifiers", "decl_specifier", "storage_class", "type_specifier",
  "type_qualifier", "struct_or_union_specifier", "struct_or_union",
  "init_declarator_list", "init_declarator", "$@5", "asm_specifier",
  "enum_specifier", "enumeration", "any_id", "declarator",
  "direct_declarator", "pointer", "opt_type_qualifiers",
  "type_qualifier_list", "parameter_type_list", "parameter_list",
  "parameter_declaration", "opt_identifier_list", "identifier_list",
  "identifier_or_ref", "abs_declarator", "direct_abs_declarator", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,    40,    42,    38,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,   273,   274,   275,   276,   277,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,    59,    44,    61,    41
};
#endif

#define YYPACT_NINF (-83)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-101)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     141,   -19,    74,    23,    46,   -83,     0,   -83,   -83,   -28,
     -83,   -83,   -83,   -83,    19,   -83,   -83,   -83,   -83,   -83,
     -83,   -83,   -83,   -83,   -83,   -83,   -83,   -83,   -83,   -83,
     -83,   -83,    -7,   -83,    61,   182,   -83,   -83,   -83,   537,
     -83,   256,   -83,   -83,   -83,   -83,   -83,    20,   -83,   -83,
      20,   -83,   -83,    15,    16,    24,   -83,   -83,   -83,   -83,
      21,   -83,    59,    23,   -83,   453,   -83,   -83,   -83,   -83,
     -83,   -83,   -83,   537,   223,   -83,   -83,   -83,    27,   -83,
      14,     9,   -83,    17,    30,   -83,    38,   -83,    38,   354,
     483,   -83,    15,    33,   -83,   -83,   -83,   -83,   -83,   297,
      74,   -83,   394,    29,    39,   -83,    36,   -83,    74,   -83,
     354,    17,   324,   -83,   -83,   -83,   -83,   -83,   -83,    49,
     510,   -83,    40,    42,    41,   -83,    44,    47,    50,   -83,
     -83,   -83,   422,   -83,   -83,    53,    58,   -83,    55,    60,
     -83,   -83,   -83,    46,   -83,    74,   -83,   -83,   -83,   -83,
     -83,   -83,   -83,   -83,    63,   -83
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,    92,     0,    81,    60,    64,    41,    42,
      43,    44,    21,    45,    46,    47,    48,    50,    51,    56,
      52,    53,    54,    55,    80,    68,    69,    57,    58,    59,
      49,    63,     0,     8,     0,     0,     4,     9,     6,     0,
       7,   102,    36,    38,    39,    40,    61,     0,    10,    62,
       0,   107,    29,    84,     0,     0,    85,    11,    12,    82,
       0,    94,    90,    93,   108,     0,    20,    75,     1,     5,
      60,    42,    46,    18,     0,   114,    16,    37,     0,    70,
      26,   109,   101,   111,     0,    66,    67,    78,    79,    31,
     103,    87,    83,     0,    86,    91,    95,    14,    15,     0,
      22,   118,   102,     0,    96,    98,     0,    17,     0,    73,
      31,   110,     0,   113,    13,    65,    77,    32,    34,     0,
      33,   105,     0,     0,   104,    76,    72,     0,    23,    24,
     100,   117,     0,   112,    71,     0,     0,   116,     0,     0,
      35,    88,    89,     0,    19,     0,    97,    99,    74,    27,
     115,    30,   106,    25,     0,    28
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -83,   -83,   -83,    67,   -40,   -83,   -60,   -83,   -83,   -83,
     -83,   -83,   -83,   -83,   -83,   -15,   -83,     2,   -37,   -83,
     -83,     6,   -83,   -83,   -83,    -5,   -83,   -83,   -83,   -83,
      -3,    -2,   -48,   -34,   -83,   -83,   -82,   -83,     3,   -83,
     -83,   -83,    31,    26
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_uint8 yydefgoto[] =
{
       0,    34,    35,    36,    85,    37,    38,   100,    39,   127,
     128,    40,   110,   154,    89,   119,   120,    99,    42,    43,
      44,    45,    46,    47,    78,    79,   135,    48,    49,    50,
      51,    52,    53,    54,    62,    63,   103,   104,   105,   123,
     124,    56,    82,    83
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      60,    64,    41,    55,    77,    98,    92,    81,   122,    61,
      87,    65,    74,   -82,     4,     5,    59,    57,    90,     2,
     112,     4,     5,    59,    58,    97,     5,    59,    95,   118,
     138,     7,    66,    92,    67,   -82,    77,    41,    55,    80,
      81,    73,   -82,    75,    86,   -82,   115,    88,   116,    91,
     118,   113,     5,    59,  -100,    84,    31,   -72,   -72,   109,
     140,    68,    77,     3,    93,    77,   114,    94,    81,    96,
     107,   108,    60,    84,   125,   131,   102,     2,     3,     4,
       5,    59,   133,   132,   139,   143,   141,   121,   142,   109,
     144,   148,   102,   149,   145,   136,   151,   126,   129,   155,
     130,   150,    69,   134,     0,   106,   126,   111,     0,     0,
       0,     0,     0,     0,   102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   102,   147,     0,     0,     0,     0,
     152,    -2,     1,   153,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,     0,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,     0,     0,     0,     0,     0,
       0,    32,    -3,     1,    33,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,     0,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,     0,     0,     0,     0,
       0,     0,    32,     0,     0,    33,    74,     3,     4,     5,
       6,     7,     8,    71,    10,    11,     0,    13,    72,     0,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    75,     0,    74,
       3,     4,     5,     6,     7,     8,    71,    10,    11,   101,
      13,    72,     0,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      75,     0,     0,     0,     0,     0,     0,     0,     0,    76,
       2,     3,     4,     5,     6,     7,     8,    71,    10,    11,
       0,    13,    72,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    70,     7,     8,    71,    10,    11,     0,    13,    72,
      76,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     0,     0,
       0,    70,     7,     8,    71,    10,    11,    12,    13,    14,
     137,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,     0,     0,
       0,     0,     0,     0,     0,     0,   117,    74,     3,     4,
       5,     6,     7,     8,    71,    10,    11,     0,    13,    72,
       0,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    75,    70,
       7,     8,    71,    10,    11,     0,    13,    72,     0,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,     0,     0,     0,   146,
      70,     7,     8,    71,    10,    11,    12,    13,    14,     0,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,     0,    84,     5,
       6,     7,     8,    71,    10,    11,     0,    13,    72,     0,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    70,     7,     8,
      71,    10,    11,    12,    13,    14,     0,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    70,     7,     8,    71,    10,    11,
       0,    13,    72,     0,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31
};

static const yytype_int16 yycheck[] =
{
       2,     4,     0,     0,    41,    65,    54,    41,    90,     3,
      50,    39,     3,    13,     5,     6,     7,    36,     3,     3,
       3,     5,     6,     7,    43,    65,     6,     7,    62,    89,
     112,     8,    13,    81,    41,    35,    73,    35,    35,    41,
      74,    39,    42,    34,    47,    45,    86,    50,    88,    34,
     110,    34,     6,     7,    40,    35,    33,    43,    44,    45,
     120,     0,    99,     4,    40,   102,    36,    46,   102,    63,
      43,    44,    74,    35,    41,    46,    74,     3,     4,     5,
       6,     7,    46,    44,    35,    44,    46,    90,    46,    45,
      43,    38,    90,    35,    44,   110,    36,    99,   100,    36,
     102,    46,    35,   108,    -1,    74,   108,    81,    -1,    -1,
      -1,    -1,    -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   132,   132,    -1,    -1,    -1,    -1,
     143,     0,     1,   145,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,    -1,
      -1,    40,     0,     1,    43,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    -1,
      -1,    -1,    40,    -1,    -1,    43,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    46,
      14,    15,    -1,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      43,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      -1,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      46,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    42,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
      -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,     7,
       8,     9,    10,    11,    12,    -1,    14,    15,    -1,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    -1,    -1,    -1,    37,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    -1,    35,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    -1,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    -1,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    40,    43,    48,    49,    50,    52,    53,    55,
      58,    64,    65,    66,    67,    68,    69,    70,    74,    75,
      76,    77,    78,    79,    80,    85,    88,    36,    43,     7,
      78,    68,    81,    82,    77,    39,    13,    41,     0,    50,
       7,    10,    15,    64,     3,    34,    43,    65,    71,    72,
      78,    80,    89,    90,    35,    51,    77,    51,    77,    61,
       3,    34,    79,    40,    46,    80,    68,    51,    53,    64,
      54,    46,    64,    83,    84,    85,    89,    43,    44,    45,
      59,    90,     3,    34,    36,    51,    51,    42,    53,    62,
      63,    77,    83,    86,    87,    41,    78,    56,    57,    78,
      78,    46,    44,    46,    72,    73,    62,    46,    83,    35,
      53,    46,    46,    44,    43,    44,    37,    85,    38,    35,
      46,    36,    77,    78,    60,    36
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    47,    48,    48,    49,    49,    50,    50,    50,    50,
      50,    50,    50,    51,    52,    52,    53,    53,    54,    53,
      55,    55,    56,    56,    57,    57,    59,    60,    58,    61,
      58,    62,    62,    62,    63,    63,    64,    64,    65,    65,
      65,    66,    66,    66,    66,    66,    66,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    68,    68,    69,    69,    69,    70,    70,
      71,    71,    72,    73,    72,    74,    74,    75,    75,    75,
      76,    77,    77,    78,    78,    79,    79,    79,    79,    79,
      80,    80,    81,    81,    82,    82,    83,    83,    84,    84,
      85,    85,    85,    86,    86,    87,    87,    88,    88,    89,
      89,    89,    90,    90,    90,    90,    90,    90,    90
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     2,     2,     2,     3,     3,     2,     3,     0,     5,
       2,     1,     0,     1,     1,     3,     0,     0,     7,     0,
       5,     0,     1,     1,     1,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     2,     2,     1,     1,
       1,     3,     1,     0,     4,     2,     3,     3,     2,     2,
       1,     1,     1,     2,     1,     1,     3,     2,     4,     4,
       2,     3,     0,     1,     1,     2,     1,     3,     1,     3,
       2,     2,     1,     0,     1,     1,     3,     1,     2,     1,
       2,     1,     3,     2,     1,     4,     3,     3,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 11: /* external_declaration: error T_MATCHRBRACE  */
#line 193 "./grammar.y"
        {
	    yyerrok;
	}
#line 1582 "y.tab.c"
    break;

  case 12: /* external_declaration: error ';'  */
#line 197 "./grammar.y"
        {
	    yyerrok;
	}
#line 1590 "y.tab.c"
    break;

  case 14: /* linkage_specification: T_EXTERN T_STRING_LITERAL braces  */
#line 208 "./grammar.y"
        {
	    /* Provide an empty action here so bison will not complain about
	     * incompatible types in the default action it normally would
	     * have generated.
	     */
	}
#line 1601 "y.tab.c"
    break;

  case 15: /* linkage_specification: T_EXTERN T_STRING_LITERAL declaration  */
#line 215 "./grammar.y"
        {
	    /* empty */
	}
#line 1609 "y.tab.c"
    break;

  case 16: /* declaration: decl_specifiers ';'  */
#line 222 "./grammar.y"
        {
#if OPT_LINTLIBRARY
	    if (types_out && want_typedef()) {
		gen_declarations(&(yyvsp[-1].decl_spec), (DeclaratorList *)0);
		flush_varargs();
	    }
#endif
	    free_decl_spec(&(yyvsp[-1].decl_spec));
	    end_typedef();
	}
#line 1624 "y.tab.c"
    break;

  case 17: /* declaration: decl_specifiers init_declarator_list ';'  */
#line 233 "./grammar.y"
        {
	    if (func_params != NULL) {
		set_param_types(func_params, &(yyvsp[-2].decl_spec), &(yyvsp[-1].decl_list));
	    } else {
		gen_declarations(&(yyvsp[-2].decl_spec), &(yyvsp[-1].decl_list));
#if OPT_LINTLIBRARY
		flush_varargs();
#endif
		free_decl_list(&(yyvsp[-1].decl_list));
	    }
	    free_decl_spec(&(yyvsp[-2].decl_spec));
	    end_typedef();
	}
#line 1642 "y.tab.c"
    break;

  case 18: /* $@1: %empty  */
#line 247 "./grammar.y"
        {
	    cur_decl_spec_flags = (yyvsp[0].decl_spec).flags;
	    free_decl_spec(&(yyvsp[0].decl_spec));
	}
#line 1651 "y.tab.c"
    break;

  case 19: /* declaration: any_typedef decl_specifiers $@1 opt_declarator_list ';'  */
#line 252 "./grammar.y"
        {
	    end_typedef();
	}
#line 1659 "y.tab.c"
    break;

  case 20: /* any_typedef: T_EXTENSION T_TYPEDEF  */
#line 259 "./grammar.y"
        {
	    begin_typedef();
	}
#line 1667 "y.tab.c"
    break;

  case 21: /* any_typedef: T_TYPEDEF  */
#line 263 "./grammar.y"
        {
	    begin_typedef();
	}
#line 1675 "y.tab.c"
    break;

  case 24: /* declarator_list: declarator  */
#line 275 "./grammar.y"
        {
	    int flags = cur_decl_spec_flags;

	    /* If the typedef is a pointer type, then reset the short type
	     * flags so it does not get promoted.
	     */
	    if (strcmp((yyvsp[0].declarator)->text, (yyvsp[0].declarator)->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, (yyvsp[0].declarator)->name, NULL, flags);
	    free_declarator((yyvsp[0].declarator));
	}
#line 1691 "y.tab.c"
    break;

  case 25: /* declarator_list: declarator_list ',' declarator  */
#line 287 "./grammar.y"
        {
	    int flags = cur_decl_spec_flags;

	    if (strcmp((yyvsp[0].declarator)->text, (yyvsp[0].declarator)->name) != 0)
		flags &= ~(DS_CHAR | DS_SHORT | DS_FLOAT);
	    new_symbol(typedef_names, (yyvsp[0].declarator)->name, NULL, flags);
	    free_declarator((yyvsp[0].declarator));
	}
#line 1704 "y.tab.c"
    break;

  case 26: /* $@2: %empty  */
#line 299 "./grammar.y"
        {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    if ((yyvsp[0].declarator)->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &((yyvsp[0].declarator)->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
#line 1719 "y.tab.c"
    break;

  case 27: /* $@3: %empty  */
#line 310 "./grammar.y"
        {
	    /* If we're converting to K&R and we've got a nominally K&R
	     * function which has a parameter which is ANSI (i.e., a prototyped
	     * function pointer), then we must override the deciphered value of
	     * 'func_def' so that the parameter will be converted.
	     */
	    if (func_style == FUNC_TRADITIONAL
	     && haveAnsiParam()
	     && (yyvsp[-3].declarator)->head->func_def == func_style) {
		(yyvsp[-3].declarator)->head->func_def = FUNC_BOTH;
	    }

	    func_params = NULL;

	    if (cur_file->convert)
		gen_func_definition(&(yyvsp[-4].decl_spec), (yyvsp[-3].declarator));
	    gen_prototype(&(yyvsp[-4].decl_spec), (yyvsp[-3].declarator));
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&(yyvsp[-4].decl_spec));
	    free_declarator((yyvsp[-3].declarator));
	}
#line 1747 "y.tab.c"
    break;

  case 29: /* $@4: %empty  */
#line 335 "./grammar.y"
        {
	    if ((yyvsp[0].declarator)->func_def == FUNC_NONE) {
		yyerror("syntax error");
		YYERROR;
	    }
	    func_params = &((yyvsp[0].declarator)->head->params);
	    func_params->begin_comment = cur_file->begin_comment;
	    func_params->end_comment = cur_file->end_comment;
	}
#line 1761 "y.tab.c"
    break;

  case 30: /* function_definition: declarator $@4 opt_declaration_list T_LBRACE T_MATCHRBRACE  */
#line 345 "./grammar.y"
        {
	    DeclSpec decl_spec;

	    func_params = NULL;

	    new_decl_spec(&decl_spec, dft_decl_spec(), (yyvsp[-4].declarator)->begin, DS_NONE);
	    if (cur_file->convert)
		gen_func_definition(&decl_spec, (yyvsp[-4].declarator));
	    gen_prototype(&decl_spec, (yyvsp[-4].declarator));
#if OPT_LINTLIBRARY
	    flush_varargs();
#endif
	    free_decl_spec(&decl_spec);
	    free_declarator((yyvsp[-4].declarator));
	}
#line 1781 "y.tab.c"
    break;

  case 37: /* decl_specifiers: decl_specifiers decl_specifier  */
#line 376 "./grammar.y"
        {
	    join_decl_specs(&(yyval.decl_spec), &(yyvsp[-1].decl_spec), &(yyvsp[0].decl_spec));
	    free_decl_spec(&(yyvsp[-1].decl_spec));
	    free_decl_spec(&(yyvsp[0].decl_spec));
	}
#line 1791 "y.tab.c"
    break;

  case 41: /* storage_class: T_AUTO  */
#line 391 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1799 "y.tab.c"
    break;

  case 42: /* storage_class: T_EXTERN  */
#line 395 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_EXTERN);
	}
#line 1807 "y.tab.c"
    break;

  case 43: /* storage_class: T_REGISTER  */
#line 399 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1815 "y.tab.c"
    break;

  case 44: /* storage_class: T_STATIC  */
#line 403 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_STATIC);
	}
#line 1823 "y.tab.c"
    break;

  case 45: /* storage_class: T_INLINE  */
#line 407 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_INLINE);
	}
#line 1831 "y.tab.c"
    break;

  case 46: /* storage_class: T_EXTENSION  */
#line 411 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_JUNK);
	}
#line 1839 "y.tab.c"
    break;

  case 47: /* type_specifier: T_CHAR  */
#line 418 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_CHAR);
	}
#line 1847 "y.tab.c"
    break;

  case 48: /* type_specifier: T_DOUBLE  */
#line 422 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1855 "y.tab.c"
    break;

  case 49: /* type_specifier: T_LONG_DOUBLE  */
#line 426 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1863 "y.tab.c"
    break;

  case 50: /* type_specifier: T_FLOAT  */
#line 430 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_FLOAT);
	}
#line 1871 "y.tab.c"
    break;

  case 51: /* type_specifier: T_INT  */
#line 434 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1879 "y.tab.c"
    break;

  case 52: /* type_specifier: T_LONG  */
#line 438 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1887 "y.tab.c"
    break;

  case 53: /* type_specifier: T_SHORT  */
#line 442 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_SHORT);
	}
#line 1895 "y.tab.c"
    break;

  case 54: /* type_specifier: T_SIGNED  */
#line 446 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1903 "y.tab.c"
    break;

  case 55: /* type_specifier: T_UNSIGNED  */
#line 450 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1911 "y.tab.c"
    break;

  case 56: /* type_specifier: T_VOID  */
#line 454 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1919 "y.tab.c"
    break;

  case 57: /* type_specifier: T_Bool  */
#line 458 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_CHAR);
	}
#line 1927 "y.tab.c"
    break;

  case 58: /* type_specifier: T_Complex  */
#line 462 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1935 "y.tab.c"
    break;

  case 59: /* type_specifier: T_Imaginary  */
#line 466 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1943 "y.tab.c"
    break;

  case 60: /* type_specifier: T_TYPEDEF_NAME  */
#line 470 "./grammar.y"
        {
	    Symbol *s;
	    s = find_symbol(typedef_names, (yyvsp[0].text).text);
	    if (s != NULL)
		new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, s->flags);
	}
#line 1954 "y.tab.c"
    break;

  case 63: /* type_qualifier: T_TYPE_QUALIFIER  */
#line 482 "./grammar.y"
        {
	    new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, DS_NONE);
	}
#line 1962 "y.tab.c"
    break;

  case 64: /* type_qualifier: T_DEFINE_NAME  */
#line 486 "./grammar.y"
        {
	    /* This rule allows the <pointer> nonterminal to scan #define
	     * names as if they were type modifiers.
	     */
	    Symbol *s;
	    s = find_symbol(define_names, (yyvsp[0].text).text);
	    if (s != NULL)
		new_decl_spec(&(yyval.decl_spec), (yyvsp[0].text).text, (yyvsp[0].text).begin, s->flags);
	}
#line 1976 "y.tab.c"
    break;

  case 65: /* struct_or_union_specifier: struct_or_union any_id braces  */
#line 499 "./grammar.y"
        {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(2 + strlen((yyvsp[-2].text).text) + strlen((yyvsp[-1].text).text));
	        (void)sprintf(s = temp_buf, "%s %s", (yyvsp[-2].text).text, (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-2].text).begin, DS_NONE);
	}
#line 1989 "y.tab.c"
    break;

  case 66: /* struct_or_union_specifier: struct_or_union braces  */
#line 508 "./grammar.y"
        {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "%s {}", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-1].text).begin, DS_NONE);
	}
#line 2002 "y.tab.c"
    break;

  case 67: /* struct_or_union_specifier: struct_or_union any_id  */
#line 517 "./grammar.y"
        {
	    need_temp(2 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "%s %s", (yyvsp[-1].text).text, (yyvsp[0].text).text);
	    new_decl_spec(&(yyval.decl_spec), temp_buf, (yyvsp[-1].text).begin, DS_NONE);
	}
#line 2012 "y.tab.c"
    break;

  case 68: /* struct_or_union: T_STRUCT  */
#line 526 "./grammar.y"
        {
	    imply_typedef((yyval.text).text);
	}
#line 2020 "y.tab.c"
    break;

  case 69: /* struct_or_union: T_UNION  */
#line 530 "./grammar.y"
        {
	    imply_typedef((yyval.text).text);
	}
#line 2028 "y.tab.c"
    break;

  case 70: /* init_declarator_list: init_declarator  */
#line 537 "./grammar.y"
        {
	    new_decl_list(&(yyval.decl_list), (yyvsp[0].declarator));
	}
#line 2036 "y.tab.c"
    break;

  case 71: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 541 "./grammar.y"
        {
	    add_decl_list(&(yyval.decl_list), &(yyvsp[-2].decl_list), (yyvsp[0].declarator));
	}
#line 2044 "y.tab.c"
    break;

  case 72: /* init_declarator: declarator  */
#line 548 "./grammar.y"
        {
	    if ((yyvsp[0].declarator)->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator((yyvsp[0].declarator));
		fputs(cur_text(), cur_file->tmp_file);
	    }
	    cur_declarator = (yyval.declarator);
	}
#line 2057 "y.tab.c"
    break;

  case 73: /* $@5: %empty  */
#line 557 "./grammar.y"
        {
	    if ((yyvsp[-1].declarator)->func_def != FUNC_NONE && func_params == NULL &&
		func_style == FUNC_TRADITIONAL && cur_file->convert) {
		gen_func_declarator((yyvsp[-1].declarator));
		fputs(" =", cur_file->tmp_file);
	    }
	}
#line 2069 "y.tab.c"
    break;

  case 76: /* asm_specifier: parameter_declaration T_ASM T_ASMARG  */
#line 570 "./grammar.y"
        {
	    free_parameter((yyvsp[-2].parameter));
	}
#line 2077 "y.tab.c"
    break;

  case 77: /* enum_specifier: enumeration any_id braces  */
#line 577 "./grammar.y"
        {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(6 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "enum %s", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-2].text).begin, DS_NONE);
	}
#line 2090 "y.tab.c"
    break;

  case 78: /* enum_specifier: enumeration braces  */
#line 586 "./grammar.y"
        {
	    char *s;
	    if ((s = implied_typedef()) == 0) {
		need_temp(4 + strlen((yyvsp[-1].text).text));
		(void)sprintf(s = temp_buf, "%s {}", (yyvsp[-1].text).text);
	    }
	    new_decl_spec(&(yyval.decl_spec), s, (yyvsp[-1].text).begin, DS_NONE);
	}
#line 2103 "y.tab.c"
    break;

  case 79: /* enum_specifier: enumeration any_id  */
#line 595 "./grammar.y"
        {
	    need_temp(6 + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "enum %s", (yyvsp[0].text).text);
	    new_decl_spec(&(yyval.decl_spec), temp_buf, (yyvsp[-1].text).begin, DS_NONE);
	}
#line 2113 "y.tab.c"
    break;

  case 80: /* enumeration: T_ENUM  */
#line 604 "./grammar.y"
        {
	    imply_typedef("enum");
	    (yyval.text) = (yyvsp[0].text);
	}
#line 2122 "y.tab.c"
    break;

  case 83: /* declarator: pointer direct_declarator  */
#line 617 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[0].declarator);

	    need_temp(1 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].declarator)->text));
	    (void)sprintf(temp_buf, "%s%s", (yyvsp[-1].text).text, (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-1].text).begin;
	    (yyval.declarator)->pointer = TRUE;
	}
#line 2138 "y.tab.c"
    break;

  case 85: /* direct_declarator: identifier_or_ref  */
#line 633 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, (yyvsp[0].text).text, (yyvsp[0].text).begin);
	}
#line 2146 "y.tab.c"
    break;

  case 86: /* direct_declarator: '(' declarator ')'  */
#line 637 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(2 + strlen((yyvsp[-1].declarator)->text));
	    (void)sprintf(temp_buf, "(%s)", (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-2].text).begin;
	}
#line 2161 "y.tab.c"
    break;

  case 87: /* direct_declarator: direct_declarator T_BRACKETS  */
#line 648 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(1 + strlen((yyvsp[-1].declarator)->text) + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "%s%s", (yyval.declarator)->text, (yyvsp[0].text).text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	}
#line 2175 "y.tab.c"
    break;

  case 88: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 658 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator("%s()", (yyvsp[-3].declarator)->name, (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
#line 2187 "y.tab.c"
    break;

  case 89: /* direct_declarator: direct_declarator '(' opt_identifier_list ')'  */
#line 666 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator("%s()", (yyvsp[-3].declarator)->name, (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_TRADITIONAL;
	}
#line 2199 "y.tab.c"
    break;

  case 90: /* pointer: '*' opt_type_qualifiers  */
#line 677 "./grammar.y"
        {
	    need_temp(2 + strlen((yyvsp[0].text).text));
	    (void)sprintf((yyval.text).text, "*%.*s", MAX_TEXT_SIZE - 2, (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	}
#line 2209 "y.tab.c"
    break;

  case 91: /* pointer: '*' opt_type_qualifiers pointer  */
#line 683 "./grammar.y"
        {
	    need_temp(2 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].text).text));
	    (void)sprintf((yyval.text).text, "*%.*s%.*s",
			  (MAX_TEXT_SIZE / 2) - 2, (yyvsp[-1].text).text,
			  (MAX_TEXT_SIZE / 2) - 2, (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-2].text).begin;
	}
#line 2221 "y.tab.c"
    break;

  case 92: /* opt_type_qualifiers: %empty  */
#line 694 "./grammar.y"
        {
	    strcpy((yyval.text).text, "");
	    (yyval.text).begin = 0L;
	}
#line 2230 "y.tab.c"
    break;

  case 94: /* type_qualifier_list: type_qualifier  */
#line 703 "./grammar.y"
        {
	    need_temp(2 + strlen((yyvsp[0].decl_spec).text));
	    (void)sprintf((yyval.text).text, "%s ", (yyvsp[0].decl_spec).text);
	    (yyval.text).begin = (yyvsp[0].decl_spec).begin;
	    free((yyvsp[0].decl_spec).text);
	}
#line 2241 "y.tab.c"
    break;

  case 95: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 710 "./grammar.y"
        {
	    need_temp(1 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].decl_spec).text));
	    (void)sprintf((yyval.text).text, "%.*s%.*s ",
			  (MAX_TEXT_SIZE / 2) - 2, (yyvsp[-1].text).text,
			  (MAX_TEXT_SIZE / 2) - 2, (yyvsp[0].decl_spec).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	    free((yyvsp[0].decl_spec).text);
	}
#line 2254 "y.tab.c"
    break;

  case 97: /* parameter_type_list: parameter_list ',' T_ELLIPSIS  */
#line 723 "./grammar.y"
        {
	    add_ident_list(&(yyval.param_list), &(yyvsp[-2].param_list), "...");
	}
#line 2262 "y.tab.c"
    break;

  case 98: /* parameter_list: parameter_declaration  */
#line 730 "./grammar.y"
        {
	    new_param_list(&(yyval.param_list), (yyvsp[0].parameter));
	}
#line 2270 "y.tab.c"
    break;

  case 99: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 734 "./grammar.y"
        {
	    add_param_list(&(yyval.param_list), &(yyvsp[-2].param_list), (yyvsp[0].parameter));
	}
#line 2278 "y.tab.c"
    break;

  case 100: /* parameter_declaration: decl_specifiers declarator  */
#line 741 "./grammar.y"
        {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[-1].decl_spec), (yyvsp[0].declarator));
	}
#line 2287 "y.tab.c"
    break;

  case 101: /* parameter_declaration: decl_specifiers abs_declarator  */
#line 746 "./grammar.y"
        {
	    check_untagged(&(yyvsp[-1].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[-1].decl_spec), (yyvsp[0].declarator));
	}
#line 2296 "y.tab.c"
    break;

  case 102: /* parameter_declaration: decl_specifiers  */
#line 751 "./grammar.y"
        {
	    check_untagged(&(yyvsp[0].decl_spec));
	    (yyval.parameter) = new_parameter(&(yyvsp[0].decl_spec), (Declarator *)0);
	}
#line 2305 "y.tab.c"
    break;

  case 103: /* opt_identifier_list: %empty  */
#line 759 "./grammar.y"
        {
	    new_ident_list(&(yyval.param_list));
	}
#line 2313 "y.tab.c"
    break;

  case 105: /* identifier_list: any_id  */
#line 767 "./grammar.y"
        {
	    new_ident_list(&(yyval.param_list));
	    add_ident_list(&(yyval.param_list), &(yyval.param_list), (yyvsp[0].text).text);
	}
#line 2322 "y.tab.c"
    break;

  case 106: /* identifier_list: identifier_list ',' any_id  */
#line 772 "./grammar.y"
        {
	    add_ident_list(&(yyval.param_list), &(yyvsp[-2].param_list), (yyvsp[0].text).text);
	}
#line 2330 "y.tab.c"
    break;

  case 107: /* identifier_or_ref: any_id  */
#line 779 "./grammar.y"
        {
	    (yyval.text) = (yyvsp[0].text);
	}
#line 2338 "y.tab.c"
    break;

  case 108: /* identifier_or_ref: '&' any_id  */
#line 783 "./grammar.y"
        {
	    need_temp(2 + strlen((yyvsp[0].text).text));
#if OPT_LINTLIBRARY
	    if (lintLibrary()) { /* Lint doesn't grok C++ ref variables */
		(yyval.text) = (yyvsp[0].text);
	    } else
#endif
		(void)sprintf((yyval.text).text, "&%.*s", MAX_TEXT_SIZE - 2, (yyvsp[0].text).text);
	    (yyval.text).begin = (yyvsp[-1].text).begin;
	}
#line 2353 "y.tab.c"
    break;

  case 109: /* abs_declarator: pointer  */
#line 797 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, "", (yyvsp[0].text).begin);
	}
#line 2361 "y.tab.c"
    break;

  case 110: /* abs_declarator: pointer direct_abs_declarator  */
#line 801 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[0].declarator);

	    need_temp(1 + strlen((yyvsp[-1].text).text) + strlen((yyvsp[0].declarator)->text));
	    (void)sprintf(temp_buf, "%s%s", (yyvsp[-1].text).text, (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-1].text).begin;
	}
#line 2376 "y.tab.c"
    break;

  case 112: /* direct_abs_declarator: '(' abs_declarator ')'  */
#line 816 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(3 + strlen((yyvsp[-1].declarator)->text));
	    (void)sprintf(temp_buf, "(%s)", (yyval.declarator)->text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	    (yyval.declarator)->begin = (yyvsp[-2].text).begin;
	}
#line 2391 "y.tab.c"
    break;

  case 113: /* direct_abs_declarator: direct_abs_declarator T_BRACKETS  */
#line 827 "./grammar.y"
        {
	    (yyval.declarator) = (yyvsp[-1].declarator);

	    need_temp(1 + strlen((yyvsp[-1].declarator)->text) + strlen((yyvsp[0].text).text));
	    (void)sprintf(temp_buf, "%s%s", (yyval.declarator)->text, (yyvsp[0].text).text);

	    free((yyval.declarator)->text);
	    (yyval.declarator)->text = xstrdup(temp_buf);
	}
#line 2405 "y.tab.c"
    break;

  case 114: /* direct_abs_declarator: T_BRACKETS  */
#line 837 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator((yyvsp[0].text).text, "", (yyvsp[0].text).begin);
	}
#line 2413 "y.tab.c"
    break;

  case 115: /* direct_abs_declarator: direct_abs_declarator '(' parameter_type_list ')'  */
#line 841 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-3].declarator)->begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = (yyvsp[-3].declarator);
	    (yyval.declarator)->head = ((yyvsp[-3].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-3].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
#line 2425 "y.tab.c"
    break;

  case 116: /* direct_abs_declarator: direct_abs_declarator '(' ')'  */
#line 849 "./grammar.y"
        {
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-2].declarator)->begin);
	    (yyval.declarator)->func_stack = (yyvsp[-2].declarator);
	    (yyval.declarator)->head = ((yyvsp[-2].declarator)->func_stack == NULL) ? (yyval.declarator) : (yyvsp[-2].declarator)->head;
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
#line 2436 "y.tab.c"
    break;

  case 117: /* direct_abs_declarator: '(' parameter_type_list ')'  */
#line 856 "./grammar.y"
        {
	    Declarator *d;

	    d = new_declarator("", "", (yyvsp[-2].text).begin);
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-2].text).begin);
	    (yyval.declarator)->params = (yyvsp[-1].param_list);
	    (yyval.declarator)->func_stack = d;
	    (yyval.declarator)->head = (yyval.declarator);
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
#line 2451 "y.tab.c"
    break;

  case 118: /* direct_abs_declarator: '(' ')'  */
#line 867 "./grammar.y"
        {
	    Declarator *d;

	    d = new_declarator("", "", (yyvsp[-1].text).begin);
	    (yyval.declarator) = new_declarator("%s()", "", (yyvsp[-1].text).begin);
	    (yyval.declarator)->func_stack = d;
	    (yyval.declarator)->head = (yyval.declarator);
	    (yyval.declarator)->func_def = FUNC_ANSI;
	}
#line 2465 "y.tab.c"
    break;


#line 2469 "y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 878 "./grammar.y"



#if defined(HAVE_CONFIG_H)
# include "lex.yy.c"
#else
#if defined(__EMX__) || defined(MSDOS) || defined(OS2) || defined(WIN32) || defined(vms)
# ifdef USE_flex
#  include "lexyy.c"
# else
#  include "lex_yy.c"
# endif
#else
# include "lex.yy.c"
#endif
#endif

static void
yaccError(const char *msg)
{
    func_params = NULL;
    put_error();		/* tell what line we're on, and what file */
    fprintf(stderr, "%s at token '%s'\n", msg, yytext);
}

/* Initialize the table of type qualifier keywords recognized by the lexical
 * analyzer.
 */
void
init_parser(void)
{
    static const char *keywords[] =
    {
	"const",
	"restrict",
	"volatile",
	"interrupt",
#ifdef vms
	"noshare",
	"readonly",
#endif
#if defined(MSDOS) || defined(OS2)
	"__cdecl",
	"__export",
	"__far",
	"__fastcall",
	"__fortran",
	"__huge",
	"__inline",
	"__interrupt",
	"__loadds",
	"__near",
	"__pascal",
	"__saveregs",
	"__segment",
	"__stdcall",
	"__syscall",
	"_cdecl",
	"_cs",
	"_ds",
	"_es",
	"_export",
	"_far",
	"_fastcall",
	"_fortran",
	"_huge",
	"_interrupt",
	"_loadds",
	"_near",
	"_pascal",
	"_saveregs",
	"_seg",
	"_segment",
	"_ss",
	"cdecl",
	"far",
	"huge",
	"near",
	"pascal",
#ifdef OS2
	"__far16",
#endif
#endif
#ifdef __GNUC__
    /* gcc aliases */
	"__builtin_va_arg",
	"__builtin_va_list",
	"__const",
	"__const__",
	"__gnuc_va_list",
	"__inline",
	"__inline__",
	"__restrict",
	"__restrict__",
	"__volatile",
	"__volatile__",
#endif
#ifdef __FreeBSD__
	"_Noreturn",
	"_Thread_local",
#endif
    };
    unsigned i;

    /* Initialize type qualifier table. */
    type_qualifiers = new_symbol_table();
    for (i = 0; i < sizeof(keywords) / sizeof(keywords[0]); ++i) {
	new_symbol(type_qualifiers, keywords[i], NULL, DS_NONE);
    }
}

#ifdef DEBUG_YYIN
static FILE *
copyfile(FILE *input, const char *name)
{
    FILE *output;
    char my_filename[1024];
    int n;
    int ch;
    for (n = 0; n < 999; ++n) {
	sprintf(my_filename, "%s.gen%03d", name, n);
	if ((output = fopen(my_filename, "r")) != 0) {
	    fclose(output);
	} else {
	    break;
	}
    }
    if ((output = fopen(my_filename, "w")) != 0) {
	while ((ch = fgetc(input)) != EOF) {
	    if (ferror(input))
		break;
	    fputc(ch, output);
	}
	fclose(output);
    }
    return fopen(my_filename, "r");
}
#endif /* DEBUG_YYIN */

/* Process the C source file.  Write function prototypes to the standard
 * output.  Convert function definitions and write the converted source
 * code to a temporary file.
 */
void
process_file(FILE *infile, const char *name)
{
    const char *s;

    if (strlen(name) > 2) {
	s = name + strlen(name) - 2;
	if (*s == '.') {
	    ++s;
	    if (*s == 'l' || *s == 'y')
		BEGIN LEXYACC;
#if defined(MSDOS) || defined(OS2)
	    if (*s == 'L' || *s == 'Y')
		BEGIN LEXYACC;
#endif
	}
    }

    included_files = new_symbol_table();
    typedef_names = new_symbol_table();
    define_names = new_symbol_table();
    inc_depth = -1;
    curly = 0;
    ly_count = 0;
    func_params = NULL;
#ifdef DEBUG_YYIN
    yyin = copyfile(infile, name);
#else
    yyin = infile;
#endif
    include_file(strcpy(base_file, name), func_style != FUNC_NONE);
    if (file_comments) {
#if OPT_LINTLIBRARY
	if (lintLibrary()) {
	    put_blankline(stdout);
	    begin_tracking();
	}
#endif
	put_string(stdout, "/* ");
	put_string(stdout, cur_file_name());
	put_string(stdout, " */\n");
    }
    yyparse();
    free_symbol_table(define_names);
    free_symbol_table(typedef_names);
    free_symbol_table(included_files);
}

#ifdef NO_LEAKS
void
free_parser(void)
{
    free_symbol_table(type_qualifiers);
#ifdef FLEX_SCANNER
    if (yy_current_buffer != 0)
	yy_delete_buffer(yy_current_buffer);
#endif
    if (temp_buf != 0) {
	temp_buf = 0;
	temp_len = 0;
    }
}
#endif
